Cleaned up base/initfs build file

Made following changes to bldpkg:
* Introduced makepkg function to remove dependency on external base/pkgtools/makepkg script
* Simplified code inside applypatch function
* Added pigz and plzip parallel compressors inside pkgext case/esac
* Miscellaneous fixes
This commit is contained in:
PktSurf 2022-09-07 11:00:06 +05:30
parent bf538d3cfd
commit 549283c0b8
3 changed files with 60 additions and 31 deletions

View file

@ -5,6 +5,7 @@ homepage="http://git.pktsurf.in/smlinux/tree/base/initfs"
download="http://git.pktsurf.in/smlinux/tree/base/initfs"
desc="initfs - initial file system hierarchy creator"
requires="musl"
disablepkgsymlinks=1
build() {
arch=noarch
@ -20,13 +21,9 @@ build() {
chmod 1777 tmp
chmod 0700 root
cp $srcdir/doinst.sh install/
install -Dm 755 $srcdir/$app.SMBuild $pkg/doc/$app-$version/$app.SMBuild
/bin/makepkg -l n -c n $pkgdest/$app-$version-$arch-$build.$pkgext
[ "$?" = "0" ] && sm_pkgstatus=0
mkfinalpkg
}
sha512sums="
85da0195b5e58c2b01f6ab91ed7a15ebff783325b08c5ed10722e6576974c1cedf55767eb30ccf58f41fc6c88171810ee63a0d7c7d09eb925c0572802d7754de initfs.tar.lz
"
"

View file

@ -37,4 +37,4 @@ build() {
sha512sums="
4c195f96d5c1d0dbd3c2c4c46dda2a4675c65e2cffa6b0ce7ee71d656a32dc75a6bb4d2b111395a1c01dfa7f1a0ccf579221fb63da72af7e4b9ac4b966debc29 libical-3.0.8.tar.lz
98b0b685676e7aa54e49050ec8adab4bb6cd3827fcd3977c156d841a527268cb47b3227852036f4bb195931ae8295fa6761bc96f4d4042f059193ab6f75aa27a icu-68.patch
"
"

80
bldpkg
View file

@ -50,7 +50,7 @@ If no arguments are provided, this script attempts to first look for
a build file with a .SMBuild extension that matches the name of
the parent directory, sources that .SMBuild file and starts the build.
For example, if the package build directory is $HOME/smlinux/alsa-lib, this script will
For example, if the package source directory is $HOME/smlinux/alsa-lib, this script will
look and source from alsa-lib.SMBuild and build alsa-lib package
# pwd
@ -119,6 +119,7 @@ validatebldfile() {
source $buildfile
# If any of the following variables are not set in the build file, abort.
# $download variable is optional but recommended
for buildvariables in app version build homepage desc requires ; do
if [[ ! ${!buildvariables} ]] ; then
echo "[ERROR] Required variable \"${buildvariables}\" is not set. Please check your build file."
@ -173,11 +174,11 @@ validatebldfile() {
srcdir="$PWD"
# Presume that the build file name will match the name of the parent directory
# unless otherwise overridden using -f
# unless otherwise overridden using -f <buildfile>
buildfile="$(basename $srcdir).SMBuild"
# Find all required files. If either of them don't exist, abort.
rqfiles=( makepkg installpkg upgradepkg sha512sum patch find findmnt patch tput bc tar )
rqfiles=( installpkg upgradepkg sha512sum patch find findmnt patch tput bc tar )
for requiredfile in ${rqfiles[@]}; do
if [[ ! -x $(type -p $requiredfile) ]] ; then
@ -285,6 +286,9 @@ elif [[ $OPTIND -gt 1 ]] ; then
fi
fi
# Unset OPTIND and OPTARG to avoid problems if getopts is used again in the future
unset OPTIND OPTARG
# Generate and insert sha512sums into the build file
if [[ $genchecksum = 1 ]] ; then
@ -371,7 +375,7 @@ if [[ -z $skipchecksum ]] ; then
IFS=$'\n'
for src in "$sums"; do
for src in $sums; do
echo $src | sha512sum -c
checksumresult=$?
if [[ $checksumresult != 0 ]] ; then
@ -401,13 +405,9 @@ applypatch() {
# Get relative path of the patch file
relativepath="$(basename $patchfile)"
echo "[INFO] Applying patch $relativepath.."
patch -p1 < "$patchfile"
# Grab the exit code and determine the outcome
patchresult=$?
if [[ $patchresult != 0 ]] ; then
# We use if/else to determine if the patch applied successfully
if ! patch -p1 < "$patchfile" ; then
echo "[ERROR] Patch file $patchfile failed to apply!"
exit 1
fi
}
@ -497,20 +497,26 @@ if ! inarray "${pkgext}" "${validpkgextensions[@]}" ; then
fi
# Figure out the compression tool to be used based on the $pkgext variable set in bldpkg.conf.
# At the same time, export the compressor options set for makepkg to import from the build environment.
case "$pkgext" in
tgz) compressor=gzip
compressopts="$gzipopts"
export compressopts ;;
tgz) if [[ -x /bin/pigz ]] ; then
compressor=pigz
else
compressor=gzip
fi
compressopts="$gzipopts" ;;
tbz) compressor=bzip2
compressopts="$bzipopts"
export compressopts ;;
tlz) compressor=lzip
compressopts="$lzipopts"
export compressopts ;;
compressopts="$bzipopts" ;;
tlz) if [[ -x /bin/plzip ]] ; then
compressor=plzip
else
compressor=lzip
fi
compressopts="$lzipopts" ;;
txz) compressor=xz
compressopts="$xzopts"
export compressopts ;;
compressopts="$xzopts" ;;
esac
# Borrowed from slackware's installpkg utility
@ -577,7 +583,7 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]] && [[ -z $tmpfscheckfailed ]] ; the
# Disable ccache
ccache=0
# Override preservebuilddir and preservepackagedir to remove both build and package directories
# Override preservebuilddir and preservepackagedir to remove both build and package staging directories
preservebuilddir=0
preservepackagedir=0
@ -948,6 +954,32 @@ fixbuilddirpermissions() {
echo " done."
}
#https://gist.github.com/ruario/9672717
makepkg() {
echo "[INFO] Generating SMLinux package..."
# If $disablepkgsymlinks is not set in the package build file, change any symlinks
#into shell script code
if [[ -z $disablepkgsymlinks ]] ; then
if find * -type l | grep -qm1 .; then
echo "[INFO] Found symlinks, preparing install/doinst.sh..."
find * -type l -printf '( cd %h ; rm -rf %f )\n( cd %h ; ln -sf %l %f )\n' -delete > install/symlinks
if [[ -f install/doinst.sh ]]; then
printf '\n' | cat - install/doinst.sh >> install/symlinks
fi
mv install/symlinks install/doinst.sh
fi
fi
tar cvf - . --format gnu \
--xform 'sx^\./\(.\)x\1x' \
--show-stored-names | $compressor $compressoropts > "$newpkglocation"
echo ""
echo "[INFO] SMLinux package $newpkglocation created."
}
# Function to calculate elapsed build time. runtime takes the $SECONDS variable as an argument. $SECONDS is an
# environment variable set by bash to show the number of whole seconds the shell has been running.
runtime() {
@ -1155,7 +1187,7 @@ EOF
newpkglocation="$pkgdest/$app-$version-$arch-$build.$pkgext"
# Finally create the package
makepkg -l y -c n "$newpkglocation"
makepkg "$newpkglocation"
pkgstatus=$?
# Terminate auditd daemon
@ -1208,7 +1240,7 @@ EOF
fi
fi
# Delete the package build directory if preservepackagedir is set to 0
# Delete the package staging directory if preservepackagedir is set to 0
if [[ $preservepackagedir = 0 ]] ; then
if ! inarray "${pkg}" "${protecteddirectories[@]}" ; then
rm -rf "$pkg"